package celt;

public final class Jkiss_fft_cpx {
	/** Real part */
	public float r;
	/** Image part */
	public float i;

	/**
	 * Default constructor
	 */
	public Jkiss_fft_cpx() {
	}

	/**
	 * Constructor
	 *
	 * @param real a real part
	 * @param image an image part
	 */
	public Jkiss_fft_cpx(final float real, final float image) {
		r = real;
		i = image;
	}

	/**
	 * Constructor
	 *
	 * @param cpx source
	 */
	public Jkiss_fft_cpx(final Jkiss_fft_cpx cpx) {
		r = cpx.r;
		i = cpx.i;
	}

	/**
	 * Clear data
	 */
	public final void clear() {
		this.r = 0;
		this.i = 0;
	}

	/**
	 * Set values
	 *
	 * @param cpx source
	 */
	public final void copyFrom(final Jkiss_fft_cpx cpx) {
		r = cpx.r;
		i = cpx.i;
	}

	final void set(final float real, final float image) {
		r = real;
		i = image;
	}
}
