package opus;

final class JAnalysisDenseLayer extends Jmlp {
	private final byte[] bias;
	private final byte[] input_weights;
	private final int nb_inputs;
	private final int nb_neurons;
	private final boolean sigmoid;

	JAnalysisDenseLayer(final byte[] b, final byte[] w, final int i, final int n, final boolean s) {
		bias = b;
		input_weights = w;
		nb_inputs = i;
		nb_neurons = n;
		sigmoid = s;
	}

	final void analysis_compute_dense(final float[] output, final float[] input)
	{
		final int M = this.nb_inputs;
		final int N = this.nb_neurons;
		final int stride = N;
		final byte[] b = this.bias;// java
		for( int i = 0; i < N; i++ ) {
			output[ i ] = b[ i ];
		}
		gemm_accum( output, this.input_weights, 0, N, M, stride, input );
		for( int i = 0; i < N; i++ ) {
			output[ i ] *= WEIGHTS_SCALE;
		}
		if( this.sigmoid ) {
			for( int i = 0; i < N; i++ ) {
				output[ i ] = .5f + .5f * tansig_approx( .5f * output[ i ] );// sigmoid_approx( output[i] );
			}
		} else {
			for( int i = 0; i < N; i++ ) {
				output[ i ] = tansig_approx( output[ i ] );
			}
		}
	}
}
