package opus;

/* Copyright (c) 2008-2011 Octasic Inc.
2012-2017 Jean-Marc Valin */

// mlp.c

class Jmlp {

	static final float WEIGHTS_SCALE = (1.f / 128);

	static final int MAX_NEURONS = 32;

	// #define fmadd(a, b, c) ((a)*(b)+(c)) java: extracted in place
	static final float tansig_approx(final float x)
	{
		final float N0 = 952.52801514f;
		final float N1 = 96.39235687f;
		final float N2 = 0.60863042f;
		final float D0 = 952.72399902f;
		final float D1 = 413.36801147f;
		final float D2 = 11.88600922f;
		final float X2 = x * x;
		float num = ((N2 * X2 + N1) * X2 + N0 );// fmadd( fmadd(N2, X2, N1), X2, N0 );
		final float den = ((D2 * X2 + D1) * X2 + D0);// fmadd( fmadd(D2, X2, D1), X2, D0 );
		num = num * x / den;
		if( 1.f < num ) {
			num = 1.f;
		} else if( -1.f > num ) {
			num = -1.f;
		}
		return num;
	}

	/* java: extracted in place
	private static float sigmoid_approx(final float x)
	{
		return .5f + .5f * tansig_approx( .5f * x );
	} */

	static final void gemm_accum(final float[] out, final byte[] weights, int woffset, final int rows, final int cols, final int col_stride, final float[] x)
	{
		for( int i = 0; i < rows; i++, woffset++ )
		{
			float v = out[ i ];
			for( int j = 0, jci = woffset; j < cols; j++, jci += col_stride ) {
				v += weights[ jci ] * x[ j ];
			}
			out[ i ] = v;
		}
	}

}